import { Stream } from './util/grpc';
import * as ExecutionType from './typedef/execution';
export declare type IExecution = ExecutionType.mesg.types.IExecution;
export declare type ExecutionGetInputs = ExecutionType.mesg.api.IGetExecutionRequest;
export declare type ExecutionGetOutputs = Promise<IExecution>;
export declare type ExecutionStreamInputs = ExecutionType.mesg.api.IStreamExecutionRequest;
export declare type ExecutionStreamOutputs = Stream<IExecution>;
export declare type ExecutionCreateInputs = ExecutionType.mesg.api.ICreateExecutionRequest;
export declare type ExecutionCreateOutputs = Promise<ExecutionType.mesg.api.ICreateExecutionResponse>;
export declare type ExecutionUpdateInputs = ExecutionType.mesg.api.IUpdateExecutionRequest;
export declare type ExecutionUpdateOutputs = Promise<ExecutionType.mesg.api.IUpdateExecutionResponse>;
export declare type ExecutionListInputs = ExecutionType.mesg.api.IListExecutionRequest;
export declare type ExecutionListOutputs = Promise<ExecutionType.mesg.api.IListExecutionResponse>;
export default class Execution {
    private _client;
    constructor(endpoint: string);
    create(request: ExecutionCreateInputs): ExecutionCreateOutputs;
    get(request: ExecutionGetInputs): ExecutionGetOutputs;
    update(request: ExecutionUpdateInputs): ExecutionUpdateOutputs;
    list(request: ExecutionListInputs): ExecutionListOutputs;
    stream(request: ExecutionStreamInputs): ExecutionStreamOutputs;
}
