"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const events_1 = require("events");
const encoder_1 = require("./util/encoder");
const hash = Buffer.from('hash');
class StreamMock {
    constructor() {
        this.eventEmitter = new events_1.EventEmitter();
    }
    on(event, listener) {
        this.eventEmitter.on(event, listener);
        return this;
    }
    cancel() { }
    destroy(err) { }
    emit(event, data) {
        this.eventEmitter.emit(event, data);
    }
}
exports.streams = {
    event: new StreamMock(),
    execution: new StreamMock()
};
exports.default = (endpoint) => ({
    account: {
        get() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { accounts: [] }; });
        },
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { name: "name", mnemonic: "mnemonic" }; });
        },
        delete() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        },
    },
    event: {
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        stream() { return exports.streams.event; },
    },
    execution: {
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        get() {
            return __awaiter(this, void 0, void 0, function* () { return { parentHash: hash, eventHash: Buffer.from('xxx'), status: 0, instanceHash: hash, taskKey: 'xxx', inputs: encoder_1.encode({}) }; });
        },
        stream() { return exports.streams.execution; },
        update() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { executions: [] }; });
        },
    },
    instance: {
        get() {
            return __awaiter(this, void 0, void 0, function* () { return { serviceHash: hash }; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { instances: [] }; });
        }
    },
    runner: {
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        get() {
            return __awaiter(this, void 0, void 0, function* () { return { hash: hash, address: '', instanceHash: hash }; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { runners: [] }; });
        },
        delete() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        }
    },
    service: {
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        get() {
            return __awaiter(this, void 0, void 0, function* () { return { sid: 'xxx', source: 'xxx' }; });
        },
        hash() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        exists() {
            return __awaiter(this, void 0, void 0, function* () { return { exists: true }; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { services: [] }; });
        },
    },
    process: {
        create() {
            return __awaiter(this, void 0, void 0, function* () { return { hash }; });
        },
        get() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        },
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { processes: [] }; });
        },
        delete() {
            return __awaiter(this, void 0, void 0, function* () { return {}; });
        },
    },
    ownership: {
        list() {
            return __awaiter(this, void 0, void 0, function* () { return { ownerships: [] }; });
        },
    }
});
__export(require("./types"));
