import * as ProcessType from './typedef/process';
export declare type IProcess = ProcessType.mesg.types.IProcess;
export declare type ProcessGetInputs = ProcessType.mesg.api.IGetProcessRequest;
export declare type ProcessGetOutputs = Promise<IProcess>;
export declare type ProcessListInputs = ProcessType.mesg.api.IListProcessRequest;
export declare type ProcessListOutputs = Promise<ProcessType.mesg.api.IListProcessResponse>;
export declare type ProcessCreateInputs = ProcessType.mesg.api.ICreateProcessRequest;
export declare type ProcessCreateOutputs = Promise<ProcessType.mesg.api.ICreateProcessResponse>;
export declare type ProcessDeleteInputs = ProcessType.mesg.api.IDeleteProcessRequest;
export declare type ProcessDeleteOutputs = Promise<ProcessType.mesg.api.IDeleteProcessResponse>;
export default class Process {
    private _client;
    constructor(endpoint: string);
    create(request: ProcessCreateInputs): ProcessCreateOutputs;
    get(request: ProcessGetInputs): ProcessGetOutputs;
    list(request: ProcessListInputs): ProcessListOutputs;
    delete(request: ProcessDeleteInputs): ProcessDeleteOutputs;
}
