"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tape_1 = __importDefault(require("tape"));
const grpc_1 = require("./grpc");
tape_1.default('checkStreamReady() without error', function (t) {
    t.plan(2);
    t.false(grpc_1.checkStreamReady({
        get(key) {
            t.equal(key, 'status');
            return ['x', 'ready'];
        }
    }));
});
tape_1.default('checkStreamReady() with empty statuses', function (t) {
    t.plan(1);
    t.equal(grpc_1.checkStreamReady({
        get(key) { return []; }
    }).message, 'stream header does not contain any status');
});
tape_1.default('checkStreamReady() without having ready status', function (t) {
    t.plan(1);
    t.equal(grpc_1.checkStreamReady({
        get(key) { return ['x']; }
    }).message, `stream header status is different than ready. Got x`);
});
